"""

   wled_effects_II.py   Developed by William Lucid 02/12/2023 with assist from OpenAI's ChatGPT.
   
"""

import requests
import time
import random

effect_names = [
  "Off",
  "Static",
  "Blink",
  "Breathe",
  "Sweep",
  "Ripple",
  "Sequence",
  "Fire2012",
  "Sinela",
  "Confetti",
  "Juggle",
  "BPM",
  "Atmosphere",
  "Larson Scanner",
  "Rainbow",
  "Rainbow Cycle",
  "Heat",
  "Fireworks",
  "Fire Flicker",
  "Gradient",
  "Meteor",
  "Morse",
  "Plasma",
  "Twinkle",
  "Halloween",
  "Christmas",
  "Candle",
  "Cylon",
  "Police",
  "Party",
  "Fire Truck",
  "State Police",
  "Color Wipe",
  "Scan",
  "Fade",
  "Theater Chase",
  "Theater Chase Rainbow",
  "Running Lights",
  "Twinkle Random",
  "Twinkle Fade",
  "Twinkle Fade Random",
  "Sparkle",
  "Flash Sparkle",
  "Hyper Sparkle",
  "Strobe",
  "Strobe Rainbow",
  "Multi Strobe",
  "Blink Rainbow",
  "Chase White",
  "Chase Color",
  "Chase Random",
  "Chase Rainbow",
  "Chase Flash",
  "Chase Flash Random",
  "Chase Rainbow White",
  "Rainbow Runner",
  "Scanner",
  "Dual Scanner",
  "Polar Lights",
  "Halloween Eyes",
  "Bouncing Balls",
  "Bouncing Colors",
  "Bouncing Rainbow",
  "Fire",
  "Graph",
  "Line",
  "Radar",
  "Solid",
  "Filling Up",
  "Filling Down",
  "Filling Up Down",
  "Alternating",
  "Waves",
  "Pacman",
  "Game Of Life",
  "Spooky",
  "Explosion",
  "Fireworks Random",
  "Stars",
  "Glitter",
  "Blinky",
  "Flicker",
  "Smart Larson",
  "Circus Combustus",
  "Tracer",
  "Thunderstorm",
  "Snowflakes",
  "Sinelon",
  "Breathing",
  "Pulsing",
  "Double Pulsing",
  "Triple Pulsing",
  "Christmas Tree",
  "Candy Cane",
  "Wreath",
  "Hanukkah",
  "Kwanzaa",
  "Heartbeat",
  "Bicolor Chase",
  "Bicolor Chase Rainbow",
  "Rainbow Runner Gradient",
  "Pacman Rainbow",
  "Blend",
  "Sine Blend",
  "Custom"
]  

# Use this arrary for custom URLs
urls = [
 
 
    # Boucing Balls  --url_index 0

    "http://10.0.0.9/win&A=128&CL=hFFA000&C2=h000000&FX=91&SX=128&IX=128&C1=128&C2=128&C3=128&FP=0",


    # Chase Rainbow  --url_index 1

    "http://10.0.0.9/win&A=128&CL=hFFA000&C2=h000000&FX=30&SX=128&IX=128&C1=128&C2=128&C3=128&FP=0",


    # Fireworks  --url_index 2

    "http://10.0.0.9/win&A=128&CL=hFFA000&C2=h000000&FX=42&SX=96&IX=192&C1=128&C2=128&C3=128&FP=11",

    # Boucing Balls  --url_index 3

    "http://10.0.0.9/win&A=128&CL=hFFA000&C2=h000000&FX=91&SX=128&IX=128&C1=128&C2=128&C3=128&FP=0",


    # Chase Rainbow  --url_index 4

    "http://10.0.0.9/win&A=128&CL=hFFA000&C2=h000000&FX=30&SX=128&IX=128&C1=128&C2=128&C3=128&FP=0"  
    
 
   
    ]
       
  
# Change the effect
def random_fx():
    effect = random.randrange(0, 101, 1)
    return effect   
# Change Color Palette
def random_fp():
    fp = random.randrange(0, 46, 1)
    return fp     
  
# Change seconds to sleep      
def random_seconds():
    # seconds = 10  # for demo purpose
    seconds = random.randrange(10, 60, 5)
    return seconds  

power_off = False  

#pass_value = 23  # for demo purpose
pass_value = 1

url_index = 0

# &A  0 - 255 Controls master brightness
# &IX 0 - 255 Controls effect intensity
# &SX 0 - 255 Controls speed of the effect  

url = "http://10.0.0.9/win&A=80&CL=hFFA000&C2=h000000&FX={}&SX=80&IX=128&C1=128&C2=128&C3=128&FP={}"

while not power_off:
    try:
        if pass_value % 5 == 0:  # "pass_value divided by 5 == 0, increase the divisor for less frequent custom URLs" 
            response = requests.get((urls[url_index]), headers={'Connection':'close'})
            print("The URL for pass_value ", pass_value, "is", urls[url_index])
            print(f"Response: ", {response.status_code},"Custom URL", "url_index: ", url_index)
            time.sleep(20)
            url_index = url_index + 1
            
            # Increment the pass_value variable
            if url_index == 5:
                url_index = 0
                            
            # Increment the pass_value variable
            pass_value += 1
                
        while pass_value % 5 != 0:

            effect = random_fx()
            fp = random_fp()
            seconds = random_seconds()
            print("Effect: ", effect)
            print("Calling effect: " + effect_names[effect])
            response = requests.get(url.format(effect, fp), headers={'Connection':'close'})
            print(f"Response: ", {response.status_code}, "Pass_value: ", pass_value, "Sleep", seconds, "FP: ", fp)
            time.sleep(seconds)
            
            # Increment the pass_value variable
            pass_value += 1


    except Exception as e:
        print("An error occurred:", e)
        # Set power_off flag to True
        power_off = True
        
# Increment the pass_value variable
pass_value += 1


    
"""
  
   FP = FASTLed palette is a collection of pre-defined color gradients or sequences that can be used in LED lighting 
   projects using the FASTLed library. It includes various types of color palettes such as solid colors, gradients, 
   and patterns, and allows for easy customization and manipulation of colors for different lighting effects.
   
"""   
